<div class="vertical-line">
  <div class="card rounded">
    <div class="card-header bg-success text-white text-center h5">
      {{ "User Data Collection Form" | uppercase }}
    </div>

    <div class="card-body bg-light">
      <form class="p-2" [formGroup]="userDataForm">
        <div class="form-group row">
          <label for="firstName" class="col-md-3 col-form-label">
            First Name
          </label>
          <div class="col-md-9">
            <input
              type="text"
              class="form-control"
              id="firstName"
              name="firstName"
              placeholder="Enter first name"
              formControlName="firstName"
              [ngClass]="{'is-invalid-input': errorFirstName()}"
            />
            <small class="text-danger" *ngIf="errorFirstName()"> First Name is required </small></div>
        </div>

        <div class="form-group row">
          <label for="lastName" class="col-md-3 col-form-label">
            Last Name
          </label>
          <div class="col-md-9">
            <input
              type="text"
              class="form-control"
              id="lastName"
              name="lastName"
              placeholder="Enter last name"
              formControlName="lastName"
              [ngClass]="{'is-invalid-input': errorLastName()}"
            />
            <small class="text-danger" *ngIf="errorLastName()"> Last Name is required </small>
          </div>
        </div>

        <div class="form-group row">
          <label for="email" class="col-md-3 col-form-label"> Email </label>
          <div class="col-md-9">
            <input
              type="text"
              class="form-control"
              id="email"
              name="email"
              placeholder="Enter email"
              formControlName="email"
              [ngClass]="{'is-invalid-input': errorEmail()}"
            />
            <div>
              <small 
                class="text-danger" 
                *ngIf="errorEmail()"
              > 
                Email is required 
              </small>
              <small 
                class="text-danger"
                *ngIf="val.email.errors?.email"
              >
                Please enter a valid email address
              </small>
            </div>
          </div>
        </div>

        <div class="form-group row">
          <label for="country" class="col-md-3 col-form-label"> Country </label>
          <div class="col-md-9">
            <select
              class="form-control"
              name="country"
              id="country"
              formControlName="country"
              [(ngModel)]="countries[0]"
              [ngClass]="{'is-invalid-input': errorCountry()}"
            >
              <option *ngFor="let country of countries" [value]="country">
                {{ country }}
              </option>
            </select>

            <small class="text-danger" *ngIf="errorCountry()"> Please select your country </small>
          </div>
        </div>

        <fieldset class="form-group">
          <div class="row">
            <legend class="col-form-label col-md-3 pt-0">Gender</legend>
            <div class="col-md-9">
              <div class="form-check">
                <input
                  class="form-check-input"
                  type="radio"
                  name="gender"
                  id="male"
                  value="male"
                  formControlName="gender"
                  [ngClass]="{'is-invalid-input': errorGender()}"
                />
                <label class="form-check-label" for="male"> Male </label>
              </div>

              <div class="form-check">
                <input
                  class="form-check-input"
                  type="radio"
                  name="gender"
                  id="female"
                  value="female"
                  formControlName="gender"
                  [ngClass]="{'is-invalid-input': errorGender()}"
                />
                <label class="form-check-label" for="female"> Female </label>
              </div>

              <small class="text-danger" *ngIf="errorGender()"> Please select your gender </small>
            </div>
          </div>
        </fieldset>

        <div class="text-center d-flex justify-content-center mt-4" *ngIf="isRandomUserLoading">
          <div class="spinner-border spinner-grow-mg text-primary " role="status" ></div>
          <div class="text-primary ml-3 mt-1"> Loading Random User Data... </div>
        </div>

        <div class="form-group mt-5 d-flex">
          <div class="" *ngIf="!editMode; else updateUser">
            <button
              type="submit"
              class="btn btn-primary"
              [disabled]="!this.userDataForm.valid"
              (click)="onAddCallParent(userDataForm.value)"
            >
              Add User
            </button>
          </div>

          <div class="ml-3">
            <button
              type="button"
              class="btn btn-warning"
              (click)="onGenerateCallParent()"
            >
              Generate Random User
            </button>
          </div>

          <div class="ml-3">
            <button type="button" class="btn btn-danger" (click)="onReset()">
              Reset Form
            </button>
          </div>

          <ng-template #updateUser>
            <div class="">
              <button
                type="submit"
                class="btn btn-primary"
                [disabled]="!this.userDataForm.valid"
                (click)="onUpdateCallParent(userDataForm.value)"
              >
                Update User
              </button>
            </div>
          </ng-template>
        </div>
      </form>
    </div>
  </div>
</div>
